/**
 * Expression.java
 *
 * File generated from the XValidator4::Expression uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

// End of user code
import java.util.Map;

import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import net.ihe.gazelle.xvalidation.core.exception.GazelleXValidationException;

import net.ihe.gazelle.xvalidation.core.report.Notification;
import net.ihe.gazelle.xvalidation.core.report.Report;
import org.w3c.dom.Node;

/**
 * Description of the class Expression.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Not")
@XmlRootElement(name = "Not")
@Entity
@DiscriminatorValue("not")
public class Not extends Expression implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = -4602263417541988295L;

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	public Not() {
		super();
	}
	
	public Not(Not not) {
		super(not);
	}

	@Override
	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "Not", this);
		}
		return xmlNodePresentation;
	}

	@Override
	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	@Override
	public Notification evaluate(Map<String, Node> files, ValidatorConfiguration configuration, Level level){
		boolean result;
		Notification notification = this.getExpression().evaluate(files, configuration, level);
		result = notification instanceof Report;

		Notification resultNotification;
		if (result){
			resultNotification = newNotificationForLevel(level);
		} else {
			resultNotification = newNotificationForLevel(null);
		}
		resultNotification.setXpathReport("NOT " + notification.getXpathReport());
		return resultNotification;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append(" not(");
		builder.append(this.getExpression().toString());
		builder.append(')');
		return builder.toString();
	}
	
	@Override
	public String getEditLink(){
		return "/xvalidation/expressions/not.xhtml";
	}
	
	@Override
	public AbstractExpression createCopy(){
		return new Not(this);
	}
}